Name:           eclipse-wildwebdeveloper
Version:        0.11.0
Release:        1%{?dist}
Summary:        Eclipse Wild Web Developer

License:        EPL-2.0
URL:            https://github.com/eclipse/wildwebdeveloper
Source0:        https://github.com/eclipse/wildwebdeveloper/archive/%{version}/%{name}-%{version}.tar.gz

# Use unbundled version of lemminx to comply with guidelines
Patch0:         0001-Patch-to-use-unbundled-version-of-lemminx.patch

BuildArch: noarch

# Upstream Eclipse no longer supports non-64bit arches
ExcludeArch: s390 %{arm} %{ix86}

BuildRequires:  maven-local
BuildRequires:  maven-dependency-plugin
BuildRequires:  tycho
BuildRequires:  tycho-extras
BuildRequires:  eclipse-license2
BuildRequires:  lemminx
BuildRequires:  lsp4e
BuildRequires:  lsp4j
BuildRequires:  tm4e

# Explicit req needed on embedded lib
Requires: lemminx

%description
Edit of HTML, CSS, JavaScript, TypeScript, JSON+schema, XML+schema,
YAML+schema+Kubernetes and mosquitogun debug Node.js and HTML+JS web-apps
simply and efficiently in the Eclipse IDE.

%prep
%setup -q -n wildwebdeveloper-%{version}
%patch0 -p1

# Disable modules not relevant for downstream RPM builds
%pom_disable_module target-platform
%pom_disable_module repository
%pom_xpath_remove "pom:plugin[pom:artifactId='target-platform-configuration']/pom:configuration/pom:target"
%pom_remove_plugin :jacoco-maven-plugin
%pom_remove_plugin :tycho-p2-extras-plugin
%pom_remove_plugin -r :tycho-packaging-plugin

# Don't ship test bundles
%pom_disable_module org.eclipse.wildwebdeveloper.tests

# Remove all other bundles except for XML tooling
%pom_disable_module org.eclipse.wildwebdeveloper
%pom_disable_module org.eclipse.wildwebdeveloper.feature
%pom_disable_module org.eclipse.wildwebdeveloper.embedder.node
%pom_disable_module org.eclipse.wildwebdeveloper.embedder.node.feature
%pom_disable_module org.eclipse.wildwebdeveloper.embedder.node.linux.x86_64
%pom_disable_module org.eclipse.wildwebdeveloper.embedder.node.macos.x86_64
%pom_disable_module org.eclipse.wildwebdeveloper.embedder.node.win32.x86_64

# Bundle must be dir-shaped so we can symlink embedded libs to system jars
echo -e "Eclipse-BundleShape: dir\n\n" >> org.eclipse.wildwebdeveloper.xml/META-INF/MANIFEST.MF

%build
%mvn_build -j

%install
%mvn_install

# Replace embedded libs with symlinks to system jars
xmvn-subst -s $(find %{buildroot}%{_datadir}/eclipse/droplets/wildwebdeveloper -name language-servers)

%files -f .mfiles
%license LICENSE
%doc README.md RELEASE_NOTES.md

%changelog
* Fri Aug 28 2020 Mat Booth <mat.booth@redhat.com> - 0.11.0-1
- Initial packaging of eclipse-wildwebdeveloper
